Package org.jboss.resteasy.core.registry

## Class Expression

- java.lang.Object
- - org.jboss.resteasy.core.registry.Expression

- All Implemented Interfaces:
    `Comparable<Expression>`
  Direct Known Subclasses:
    `ClassExpression`, `MethodExpression`

      public abstract class Expression
      extends Object
      implements Comparable<Expression>

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `Expression.Group` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static Pattern` | `GROUP` |
    `protected List<Expression.Group>` | `groups` |
    `protected int` | `literalCharacters` |
    `protected int` | `numCapturingGroups` |
    `protected int` | `numNonDefaultGroups` |
    `protected String` | `pathExpression` |
    `protected Pattern` | `pattern` |
    `protected String` | `regex` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Expression​(String segment, String additionalRegex)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareTo​(Expression expression)` |
    `int` | `getNumGroups()` |
    `String` | `getPathExpression()` |
    `Pattern` | `getPattern()` |
    `String` | `getRegex()` |
    `protected static int` | `groupCount​(String regex)` | Find the number of groups in the regular expression don't count escaped '('.
    `boolean` | `isStatic()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### GROUP

          public static final Pattern GROUP

    - #### pathExpression

          protected String pathExpression

    - #### regex

          protected String regex

    - #### pattern

          protected Pattern pattern

    - #### groups

          protected List<Expression.Group> groups

    - #### literalCharacters

          protected int literalCharacters

    - #### numCapturingGroups

          protected int numCapturingGroups

    - #### numNonDefaultGroups

          protected int numNonDefaultGroups

  - ### Constructor Detail

    - #### Expression

          public Expression​(String segment,
                            String additionalRegex)

  - ### Method Detail

    - #### compareTo

          public int compareTo​(Expression expression)

      Specified by:
        `compareTo` in interface `Comparable<Expression>`

    - #### groupCount

          protected static int groupCount​(String regex)

      Find the number of groups in the regular expression don't count escaped '('.
      Parameters:
        `regex` - regular expression
      Returns:
        number of groups

    - #### isStatic

          public boolean isStatic()

    - #### getNumGroups

          public int getNumGroups()

    - #### getRegex

          public String getRegex()

    - #### getPathExpression

          public String getPathExpression()

    - #### getPattern

          public Pattern getPattern()